/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef TELNET_PANEL_CPP
#define TELNET_PANEL_CPP

#include "scd_telnet.cpp"
#include "frm_telnet.cpp"
// ----------------------------------------------------------------------------

class Telnet_Panel : public wxWindow
{
private:
	bool isAltDown;

public:
	Telnet_Panel()
 	{
		SetBackgroundColour(*wxBLACK);

  		now_telnet = NULL;

		//إߴ
		caret.Create(this, 8,2);
 		this->SetCaret( &caret );

		isAltDown = false;
    }
	void SetTelnet(SCD_Telnet *t)
	{
		if( now_telnet )
		{
			now_telnet->Hide();
#ifdef __WXMSW__	//windows U[Woq, Y now_telnet e t j, h|ݯd now_telnet e
			wxSize ts = now_telnet->getWindowSize();
			wxRect r(0,0,ts.GetWidth(), ts.GetHeight() );
			RefreshRect(r);
#endif
		}
		now_telnet = t;
		if( now_telnet )
  		{
    		now_telnet->Show();
		}
		else Refresh();

#ifdef __WXGTK__	//wxGTK U[Woq, console kMU|dU֪ť
		SetBackgroundColour(*wxBLACK);
#endif
	}
	
	void OnMouseRightUp(wxMouseEvent& event)
	{   GetParent()->AddPendingEvent(event);    }
	void OnMouseLeftDown(wxMouseEvent& event)
	{
		if(now_telnet == NULL)	return;
		now_telnet->OnMouseLeftDown(event);
	}
	void OnMouseMotion(wxMouseEvent& event)
	{
		if(now_telnet == NULL)	return;
		now_telnet->OnMouseMotion(event);
	}
	void OnMouseLeftUp(wxMouseEvent& event)
	{
		if(now_telnet == NULL)	return;
		now_telnet->OnMouseLeftUp(event);
		GetParent()->AddPendingEvent(event);
	}
	void OnMouseMiddleDown(wxMouseEvent& event)
	{
		if(now_telnet == NULL)	return;
		GetParent()->AddPendingEvent(event);
	}

	void OnPaint(wxPaintEvent& event)
	{
		wxPaintDC dc(this);
		if(now_telnet == NULL)	return;
		now_telnet->OnPaint(&dc);
	}
	void OnKeyDown(wxKeyEvent& event)
	{
#ifdef __WXGTK__	// wxGTK U event.AltDown() S@ΡAzLoؤ覡
		if( event.GetKeyCode() == 307 )	isAltDown = true;
		event.m_altDown = isAltDown;
#endif

		if(now_telnet == NULL)	return;

		//obeAMi|Q now_telnet->OnKeyDown(event); Is event.Skip();
		GetParent()->ProcessEvent(event);

		int key = event.GetKeyCode();
		if( key == 13 && now_telnet->IsDisconnected() )	//_uɫ [Enter] ssu
		{
			now_telnet->reconnect();
			return;
		}
		else	now_telnet->OnKeyDown(event);
	}
	void OnKeyUp(wxKeyEvent& event)
	{
#ifdef __WXGTK__	// wxGTK U event.AltDown() S@ΡAzLoؤ覡
		if( event.GetKeyCode() == 307 )	isAltDown = false;
#endif
	}
	void OnChar(wxKeyEvent& event)
	{
		if(now_telnet == NULL)	return;

#ifdef __WXGTK__	// wxGTK U event.AltDown() S@ΡAzLoؤ覡
		event.m_altDown = isAltDown;
#endif

		GetParent()->AddPendingEvent(event);
		now_telnet->OnChar(event);
	}

	void OnSocketEvent( wxSocketEvent &e )
	{ 	GetParent()->AddPendingEvent(e);	}

	void OnFocus(wxFocusEvent& event)
	{
#ifdef __WXGTK__	// wxGTK U event.AltDown() S@ΡAzLoؤ覡
		isAltDown = false;
#endif
	}


private:

	SCD_Telnet *now_telnet;
	wxCaret caret;

    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(Telnet_Panel, wxWindow)
	EVT_SOCKET(666 , Telnet_Panel::OnSocketEvent)

	EVT_RIGHT_UP(Telnet_Panel::OnMouseRightUp)
	EVT_LEFT_DOWN(Telnet_Panel::OnMouseLeftDown)
	EVT_MOTION(Telnet_Panel::OnMouseMotion)
	EVT_LEFT_UP(Telnet_Panel::OnMouseLeftUp)
	EVT_MIDDLE_DOWN(Telnet_Panel::OnMouseMiddleDown)

	EVT_PAINT(Telnet_Panel::OnPaint)
	EVT_KEY_DOWN(Telnet_Panel::OnKeyDown)
	EVT_KEY_UP(Telnet_Panel::OnKeyUp)
	EVT_CHAR(Telnet_Panel::OnChar)

	EVT_SET_FOCUS(Telnet_Panel::OnFocus)

END_EVENT_TABLE()

// ----------------------------------------------------------------------------
#endif
